EnterPrice-web/src/main/java/pl/sda/dto/AuthorDTO.java
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pl.sda.dto;

/**
 *
 * @author PsLgComp
 */
public class AuthorDTO {
    private Integer id;
    private String name;

    public AuthorDTO() {
    }
    
    public AuthorDTO(String name) {
        this.name = name;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
    
    
}

EnterPrice-web/src/main/java/pl/sda/dto/BookDTO.java
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pl.sda.dto;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;
import pl.sda.ejb.model.Book;

/**
 *
 * @author RENT
 */
public class BookDTO {
    private Integer id;
    
    private String title;

    private String isbn;

    private int releaseYear;
    
    //private Collection<String> authors;
    
    private Collection<AuthorDTO> authors;

    public BookDTO() {
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Collection<AuthorDTO> getAuthors() {
        return this.authors;
    }

    public void setAuthors(Collection<AuthorDTO> authors) {
        this.authors = authors;
    }

    public BookDTO(String title, String isbn, int releaseYear) {
        this.title = title;
        this.isbn = isbn;
        this.releaseYear = releaseYear;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getIsbn() {
        return isbn;
    }

    public void setIsbn(String isbn) {
        this.isbn = isbn;
    }

    public int getReleaseYear() {
        return releaseYear;
    }

    public void setReleaseYear(int releaseYear) {
        this.releaseYear = releaseYear;
    }

    public String getAuthorsNames() {
        if (authors == null) return "";
        return authors.stream()
                .map(AuthorDTO::getName)
                .collect(Collectors.joining(", "));
    }
    
    public void setAuthorsNames(String author) {
        authors =Arrays.asList(author.split(",")).stream()
                .map(String::trim)
                .map(AuthorDTO::new)
                .collect(Collectors.toList());
    }
    

}

EnterPrice-web/src/main/java/pl/sda/controller/BookController.java
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pl.sda.controller;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.stream.Collectors;
import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.RequestScoped;
import javax.faces.context.FacesContext;
import pl.sda.dto.AuthorDTO;
import pl.sda.dto.BookDTO;
import pl.sda.ejb.ApplicationController;
import pl.sda.ejb.NewSessionBeanRemote;
import pl.sda.ejb.model.Author;
import pl.sda.ejb.model.Book;


/**
 *
 * @author RENT
 */
@ManagedBean(name = "frmBook")
@RequestScoped
public class BookController {
    private BookDTO book = new BookDTO();
    private BookDTO bookToDelete;
    private List<BookDTO> bookList;// = new ArrayList<>();
    //private AuthorDTO author = new AuthorDTO();
    
    /**
     * Creates a new instance of BookController
     */
    
    @ManagedProperty(value = "#{applicationController}")
    private ApplicationController applicationController;
    
    @EJB
    private NewSessionBeanRemote bookBean;
    
    private BookDTO mapBook(Book book){
        BookDTO bookDTO = new BookDTO(book.getTitle(), book.getIsbn(), book.getReleaseYear());
        bookDTO.setId(book.getId());
        bookDTO.setAuthors(book.getAuthors().stream()
                .map(a ->{
                    AuthorDTO adto = new AuthorDTO(a.getName());
                    return adto;})
                .collect(Collectors.toList()));
        return bookDTO;
    }
    
    private Book mapBookDTO(BookDTO bookDTO){
        Book book = new Book(bookDTO.getTitle(), bookDTO.getIsbn(), bookDTO.getReleaseYear());
          book.setId(bookDTO.getId());
//        book.setAuthors(bookDTO.getAuthors().stream()
//                .map(adto -> {Author a = new Author();
//                    a.setName(adto.getName());
//                    a.setId(adto.getId());
//                    return a;})
//                .collect(Collectors.toList()));
        return book;
    }
    

    public ApplicationController getApplicationController() {
        return applicationController;
    }

    public void setApplicationController(ApplicationController applicationController) {
        this.applicationController = applicationController;
    }
    public BookController() {
    }
    
    public void setTitle(String title){
       this.book.setTitle(title);
    }
    
    public String getTitle(){
        return book.getTitle();
    }
    
    public void setIsbn(String isbn){
        this.book.setIsbn(isbn);
    }
    
    public String getIsbn(){
        return this.book.getIsbn();
    }
    
    public void setReleaseYear(String releaseYear){
        this.book.setReleaseYear(Integer.parseInt(releaseYear));
    }
    
    public String getReleaseYear(){
        return Integer.toString(this.book.getReleaseYear());
    }
    
    public void addBook() {
        Book book = mapBookDTO(this.book);
        book.setAuthors(
                this.book.getAuthors().stream()
                        .map(adto -> {
                            Collection<Book> authorsBooks = null;
                            Author a = bookBean.checkIfAuthorExists(adto.getName());
                            if (a == null) {//autora nie ma w bazie
                                a = new Author();
                                a.setName(adto.getName());
                                a.setId(adto.getId());
                                authorsBooks = new ArrayList<>();
                            } else {//autor jest w bazie
                                authorsBooks = a.getBooks();
                                if (authorsBooks == null) {
                                    authorsBooks = new ArrayList<>();
                                }
                            }
                            authorsBooks.add(book);
                            a.setBooks(authorsBooks);
                            return a;
                        })
                        .collect(Collectors.toList()));
        bookBean.addBook(book);
        System.out.println(book.getTitle());
        
    }
    
    public String getAuthorsNames(){
        return this.book.getAuthorsNames();
    }
    
    public void setAuthorsNames(String author){
        this.book.setAuthorsNames(author);
    }

//    
//    public AuthorDTO getAuthor(){
//        return this.author;
//    }
//    
//    public void SetAuthor(AuthorDTO author){
//        this.author = author;
//    }
//    
    public void setBookToDelete(BookDTO book){
        this.bookToDelete = book;
    }

    public BookDTO getBookToDelete() {
        return bookToDelete;
    }
    
    
    
    
    
    public void delete(){
        boolean postback = FacesContext.getCurrentInstance().isPostback();
        if (postback){
            System.out.println("deleting book -> id = " + bookToDelete.getId()
                    + " (" + bookToDelete.getTitle() + ")");
            bookBean.deleteBookByID(bookToDelete.getId());
            System.out.println("postback = thrue");
          
        }else{
            System.out.println("postback = false");
            
        }
    }
    
    public List<BookDTO> getBooks() {
        bookList = bookBean.getBooks().stream().map(this::mapBook).collect(Collectors.toList());
        return bookList;
    }
}

EnterPrice-web/src/main/java/pl/sda/ejb/ApplicationController.java
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pl.sda.ejb;

import java.util.List;
import javax.ejb.EJB;
import javax.faces.bean.ApplicationScoped;
import javax.faces.bean.ManagedBean;
import javax.inject.Named;
import pl.sda.ejb.model.Book;

/**
 *
 * @author PsLgComp
 */
@ManagedBean(name = "applicationController")
@ApplicationScoped
public class ApplicationController {

    @EJB
    private NewSessionBeanRemote bean;
    /**
     * Creates a new instance of ApplicationController
     */
    public ApplicationController() {
    }
    
    public Book newBook = new Book();
    
    public String getTest() {
        //bean.addBook("New book title", "1234", 1410);
        return bean.test();
    }
    
    public List<Book> getBooks(){
        return bean.getBooks();
    }
    public void addBook(){
        
    }
}

EnterPrice-web/src/main/webapp/book_index.xhtml
<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets">
    <h:head>
        <title>Facelet Title</title>
        <!-- DataTable CSS /-->
        <link href="css/tablestyle.css" rel="stylesheet"/>
    </h:head>
    <h:body>
        Hello from book_index page
        <h2>Lista wszystkich książek</h2>
        <h:form>
            <h:dataTable value = "#{frmBook.books}" var = "book"
                         styleClass = "employeeTable"
                         headerClass = "employeeTableHeader"
                         rowClasses = "employeeTableOddRow,employeeTableEvenRow">
                <h:column>    				
                    <f:facet name = "header">ID</f:facet>    				
                        #{book.id}
                </h:column>

                <h:column>    				
                    <f:facet name = "header">Tytuł</f:facet>    				
                        #{book.title}
                </h:column>

                <h:column>
                    <f:facet name = "header">ISBN</f:facet>
                        #{book.isbn}
                </h:column>

                <h:column>
                    <f:facet name = "header">Rok Wydania</f:facet>
                        #{book.releaseYear}
                </h:column>
                <h:column>
                    <f:facet name="header">Autorzy</f:facet>
                    #{book.authorsNames}
                </h:column>

                <h:column>
                    <f:facet name = "header">Delete</f:facet>
                    <h:commandButton value = "Delete" action = "#{frmBook.delete}"  >                
                        <f:setPropertyActionListener 
                            target = "#{frmBook.bookToDelete}" value = "#{book}" />
                    </h:commandButton>
                </h:column>

            </h:dataTable>
        </h:form>
        <br/><br/>
        <h3>Dodaj nową książkę:</h3>
        <br/>
        <h:form>
            <table>
                <tr>
                    <td>Tytuł :</td>
                    <td><h:inputText size = "100" value = "#{frmBook.title}" /></td>
                </tr>

                <tr>
                    <td>ISBN :</td>
                    <td><h:inputText size = "20" value = "#{frmBook.isbn}" /></td>
                </tr>

                <tr>
                    <td>Rok wydania :</td>
                    <td><h:inputText size = "5" value = "#{frmBook.releaseYear}" /></td>
                </tr>

                <tr>
                    <td>Autorzy (należy oddzielić kolejnych przecinkiem)</td>
                    <td><h:inputText size = "100" value = "#{frmBook.authorsNames}" /></td>
                </tr>
                
                <tr>
                    <td> </td>
                    <td><h:commandButton value = "Add book" 
                                         action = "#{frmBook.addBook()}" /></td>
                </tr>
            </table>	
        </h:form>
    </h:body>
</html>

EnterPrice-web/src/main/webapp/index.xhtml
<?xml version = "1.0" encoding = "UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns = "http://www.w3.org/1999/xhtml"
      xmlns:h = "http://java.sun.com/jsf/html"
      xmlns:ui = "http://java.sun.com/jsf/facelets">

    <h:head>
        <title>Facelet Title</title>
        
        <meta charset="utf-8"/>
            <meta http-equiv="X-UA-Compatible" content="IE=edge"/>
                <meta name="viewport" content="width=device-width, initial-scale=1"/>
                    <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
                    <meta name="description" content=""/>
                        <meta name="author" content=""/>
                                <title>Blog Template for Bootstrap</title>

                                <!-- Bootstrap core CSS -->
                                <link href="css/bootstrap.min.css" rel="stylesheet"/>

                                    <!-- IE10 viewport hack for Surface/desktop Windows 8 bug -->
                                    <link href="css/ie10-viewport-bug-workaround.css" rel="stylesheet"/>

                                        <!-- Custom styles for this template -->
                                        <link href="css/blog.css" rel="stylesheet"/>

                                            <!-- Just for debugging purposes. Don't actually copy these 2 lines! -->
                                            <!--[if lt IE 9]><script src="js/ie8-responsive-file-warning.js"></script><![endif]-->
                                            <script src="js/ie-emulation-modes-warning.js"></script>
        
        
    </h:head>
    <h:body>
        <ui:include src="/static/menu.xhtml" />
        <!--h:outputText value="#{applicationController.test}"/-->
        <h:form>
            <h3>Using JSF outcome</h3>
            <h:commandButton action = "book_index" value = "Page2" />
        </h:form>
    </h:body>
</html>